package org.apache.jsp;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import org.apache.jasper.runtime.*;
import java.sql.*;
import java.util.*;
import java.util.Vector;
import java.util.Iterator;
import beans.InvalidNameException;
import beans.NamingConflictException;
import beans.DoubleInsertException;
import beans.OperationNotPermittedException;
import beans.DataNotFoundException;

public class groupAdmin_jsp extends HttpJspBase {

 
	private boolean debugMode = true;				
	private HttpServletRequest myRequest;
	public static final String ERR_MSG_KEY = "errorMessage";
	public static final String SUC_MSG_KEY = "successMessage";
	
	private void setErrorMessage(String errMsg) {
		myRequest.setAttribute(ERR_MSG_KEY, errMsg);
	}
	
	private void setSuccessMessage(String msg){
		myRequest.setAttribute(SUC_MSG_KEY, msg);
	}
	


  private static java.util.Vector _jspx_includes;

  static {
    _jspx_includes = new java.util.Vector(2);
    _jspx_includes.add("/standardheadWOhtml.jsp");
    _jspx_includes.add("/standardhead_java.jsp");
  }

  public java.util.List getIncludes() {
    return _jspx_includes;
  }

  public void _jspService(HttpServletRequest request, HttpServletResponse response)
        throws java.io.IOException, ServletException {

    JspFactory _jspxFactory = null;
    javax.servlet.jsp.PageContext pageContext = null;
    HttpSession session = null;
    ServletContext application = null;
    ServletConfig config = null;
    JspWriter out = null;
    Object page = this;
    JspWriter _jspx_out = null;


    try {
      _jspxFactory = JspFactory.getDefaultFactory();
      response.setContentType("text/html;charset=ISO-8859-1");
      pageContext = _jspxFactory.getPageContext(this, request, response,
      			null, true, 8192, true);
      application = pageContext.getServletContext();
      config = pageContext.getServletConfig();
      session = pageContext.getSession();
      out = pageContext.getOut();
      _jspx_out = out;

      out.write("\n");
      beans.LogTracker logger = null;
      synchronized (session) {
        logger = (beans.LogTracker) pageContext.getAttribute("logger", PageContext.SESSION_SCOPE);
        if (logger == null){
          try {
            logger = (beans.LogTracker) java.beans.Beans.instantiate(this.getClass().getClassLoader(), "beans.LogTracker");
          } catch (ClassNotFoundException exc) {
            throw new InstantiationException(exc.getMessage());
          } catch (Exception exc) {
            throw new ServletException("Cannot create bean of class " + "beans.LogTracker", exc);
          }
          pageContext.setAttribute("logger", logger, PageContext.SESSION_SCOPE);
        }
      }
      out.write("\n");
      beans.Tools tools = null;
      synchronized (application) {
        tools = (beans.Tools) pageContext.getAttribute("tools", PageContext.APPLICATION_SCOPE);
        if (tools == null){
          try {
            tools = (beans.Tools) java.beans.Beans.instantiate(this.getClass().getClassLoader(), "beans.Tools");
          } catch (ClassNotFoundException exc) {
            throw new InstantiationException(exc.getMessage());
          } catch (Exception exc) {
            throw new ServletException("Cannot create bean of class " + "beans.Tools", exc);
          }
          pageContext.setAttribute("tools", tools, PageContext.APPLICATION_SCOPE);
        }
      }
      out.write("\n");
      beans.DatabaseLayer dbConn = null;
      synchronized (session) {
        dbConn = (beans.DatabaseLayer) pageContext.getAttribute("dbConn", PageContext.SESSION_SCOPE);
        if (dbConn == null){
          try {
            dbConn = (beans.DatabaseLayer) java.beans.Beans.instantiate(this.getClass().getClassLoader(), "beans.DatabaseLayer");
          } catch (ClassNotFoundException exc) {
            throw new InstantiationException(exc.getMessage());
          } catch (Exception exc) {
            throw new ServletException("Cannot create bean of class " + "beans.DatabaseLayer", exc);
          }
          pageContext.setAttribute("dbConn", dbConn, PageContext.SESSION_SCOPE);
        }
      }
      out.write(" ");
      out.write("\n");
      out.write("\n");
 myRequest = request; 
      out.write("\n");
      out.write("\n\n");
if(!logger.isLoggedIn() && request.getRequestURI().indexOf("Login.jsp") < 0){
      out.write("\n\t");
      if (true) {
        pageContext.forward("Login.jsp");
        return;
      }
      out.write("\n");
}
      out.write("\n");
      out.write("\n");
      out.write("\n");
      out.write("\n");
      out.write("\n");
      beans.GroupAdmin groupAdmin = null;
      synchronized (session) {
        groupAdmin = (beans.GroupAdmin) pageContext.getAttribute("groupAdmin", PageContext.SESSION_SCOPE);
        if (groupAdmin == null){
          try {
            groupAdmin = (beans.GroupAdmin) java.beans.Beans.instantiate(this.getClass().getClassLoader(), "beans.GroupAdmin");
          } catch (ClassNotFoundException exc) {
            throw new InstantiationException(exc.getMessage());
          } catch (Exception exc) {
            throw new ServletException("Cannot create bean of class " + "beans.GroupAdmin", exc);
          }
          pageContext.setAttribute("groupAdmin", groupAdmin, PageContext.SESSION_SCOPE);
        }
      }
      out.write("\n");
      beans.StringChecker strChk = null;
      synchronized (session) {
        strChk = (beans.StringChecker) pageContext.getAttribute("strChk", PageContext.SESSION_SCOPE);
        if (strChk == null){
          try {
            strChk = (beans.StringChecker) java.beans.Beans.instantiate(this.getClass().getClassLoader(), "beans.StringChecker");
          } catch (ClassNotFoundException exc) {
            throw new InstantiationException(exc.getMessage());
          } catch (Exception exc) {
            throw new ServletException("Cannot create bean of class " + "beans.StringChecker", exc);
          }
          pageContext.setAttribute("strChk", strChk, PageContext.SESSION_SCOPE);
        }
      }
      out.write("\n\n");

String CONTACT_MAIL_ADDR = "contact@terminator.de.vu";
String UNEXPECTED_EXCEPTION_MSG = "Es trat ein unerwarteter Fehler auf. Bitte schreiben Sie eine Mail an " + CONTACT_MAIL_ADDR + " und beschreiben Sie die Situation.";
boolean changeName = beans.Tools.isKeyInRequest(request,"changeName");
boolean insertGroup = beans.Tools.isKeyInRequest(request,"insertGroup");
boolean removeUser = beans.Tools.isKeyInRequest(request,"removeUser");
boolean insertUser = beans.Tools.isKeyInRequest(request,"insertUser");
boolean changeAdmin = beans.Tools.isKeyInRequest(request,"changeAdmin");
boolean changeGroup = beans.Tools.isKeyInRequest(request,"changeGroup");
boolean deleteGroup = beans.Tools.isKeyInRequest(request,"deleteGroup");
String groupToChangeID = request.getParameter("groupToChangeID");
String userID = logger.getUserID();

if (insertGroup) {
	// hier checken, ob der Gruppenname valid ist
	String newGroupName = request.getParameter("newGroupName");
	boolean updated = false;
	try {
		updated = groupAdmin.insertGroup(newGroupName, userID);
		if (updated) {
			setSuccessMessage("Die Gruppe '" + newGroupName + "' wurde angelegt.");
			ResultSet rs = dbConn.query("select groups.groupID from groups where name = '" + newGroupName + "' and adminID = " + userID);
			if (rs.next()) {
				int newGroupID = rs.getInt("groupID");
				groupToChangeID = "" + newGroupID;
				changeGroup = true;
			}
		}
		else {
			setErrorMessage("Beim anlegen der Gruppe trat ein Fehler auf.");
		}
	}
	catch (InvalidNameException ex) {
		setErrorMessage(ex.getMessage());
	}
	catch (NamingConflictException ex) {
		setErrorMessage(ex.getMessage());
	}
	catch (SQLException ex) {
		setErrorMessage(ex.getMessage());
	}
	catch (Exception ex) {
		setErrorMessage(UNEXPECTED_EXCEPTION_MSG);
	}
}

else if (deleteGroup) {
	try {
		if (groupAdmin.deleteGroup(groupToChangeID))	{
			setSuccessMessage("Gruppe wurde gel&ouml;scht.");
		}
		else {
			setErrorMessage("Beim löschen der Gruppe trat ein Fehler auf.");
		}
	}
	catch (Exception ex) {
		setErrorMessage(UNEXPECTED_EXCEPTION_MSG);
	}
}
else if(changeName) {
	String changedGroupName = request.getParameter("changedGroupName");
	String groupIDString = request.getParameter("groupToChangeID");
	try {
		if (groupAdmin.changeGroupName(groupIDString, changedGroupName)) {
			setSuccessMessage("Der Gruppenname wurde in '" + changedGroupName + "' ge&auml;ndert.");
		}
		else {
			setErrorMessage("Beim ändern des Gruppennamen trat ein Fehler auf.");
		}
	}
	catch (InvalidNameException ex) {
		setErrorMessage(ex.getMessage());
	}
	catch (Exception ex) {
		setErrorMessage(UNEXPECTED_EXCEPTION_MSG);
	}
}
else if (changeAdmin && groupToChangeID != null) {
	String newAdminName = request.getParameter("changedAdminName");
	try {
		if (groupAdmin.changeGroupAdmin(groupToChangeID, newAdminName))	{
			setSuccessMessage("Der neue Administrator der Gruppe ist " + newAdminName + ".");
		}
		else {
			setErrorMessage("Beim &auml;ndern des Administrators trat ein Fehler auf.");
		}
	}
	catch (Exception ex) {
		setErrorMessage(UNEXPECTED_EXCEPTION_MSG);
	}
}
else if (insertUser && groupToChangeID != null) {
	String userName = request.getParameter("newUserName");
	try {
		if (groupAdmin.insertUser(groupToChangeID, userName)) {
			setSuccessMessage(userName + " wurde in die Gruppe eingef&uuml;gt.");
		}
		else {
			setErrorMessage("Beim einf&uuml;gen des Benutzers trat ein Fehler auf.");
		}
	}
	catch (DataNotFoundException ex) {
		setErrorMessage(ex.getMessage());
	}
	catch (DoubleInsertException ex) {
		setErrorMessage(ex.getMessage());
	}
	catch(SQLException ex) {
		setErrorMessage(ex.getMessage());
	}
	catch (Exception ex) {
		setErrorMessage(UNEXPECTED_EXCEPTION_MSG);
	}
}
else if (removeUser && groupToChangeID != null) {
	String userName = request.getParameter("members");
	try {
		if (groupAdmin.removeUser(groupToChangeID, userID, userName)) {
			setSuccessMessage(userName + " wurde aus der Gruppe gel&ouml;scht.");
		}
		else {
			setErrorMessage("Beim l&ouml;schen des Benutzers trat ein Fehler auf.");
		}
	}
	catch (DataNotFoundException ex) {
		setErrorMessage(ex.getMessage());
	}
	catch (OperationNotPermittedException ex) {
		setErrorMessage(ex.getMessage());
	}
	catch (SQLException ex) {
		setErrorMessage(ex.getMessage());
	}
	catch (Exception ex) {
		setErrorMessage(UNEXPECTED_EXCEPTION_MSG);
	}
}
else if((changeGroup || insertUser || removeUser || deleteGroup) && groupToChangeID == null) {
	setErrorMessage("W&auml;hlen Sie eine Gruppe um die Aktion auszuführen!");
}
      out.write("\n");
      out.write("<center>\n");
      out.write("<h1>Gruppen-Administrator");
      out.write("</h1>\n");
      out.write("</center>\n");
      out.write("<br>\n");

ResultSet rs = dbConn.query("select name, groupID from groups where adminID = " + userID  + " order by name");


      out.write("\n");
      out.write("<menu>\n\t");
      out.write("<form action=\"mainFrame.jsp\" method=\"get\" >\n\t");
      out.write("<center>\n\t");
if (rs != null && rs.next()) {
      out.write("\n\t\tSie sind Administrator in den Gruppen");
      out.write("<br>\n\t\t");
      out.write("<select size=\"5\" style=\"width:200\"name=\"groupToChangeID\">\n\t\t");

			do {
				String currentName = rs.getString("name");
				int submitGroupToChangeID = rs.getInt("groupID");
				// TODO: Das muss übersichtlicher werden!
				String submitGroupToChangeIDString = "" + submitGroupToChangeID;
				String currentChangedGroupIDString = groupToChangeID;
				String selected = (submitGroupToChangeIDString.equals(currentChangedGroupIDString)) ? "selected" : "";
				
      out.write("\n\t\t\t\t\t");
      out.write("<option value=\"");
      out.print(submitGroupToChangeID);
      out.write("\" ");
      out.print(selected);
      out.write(">");
      out.print(currentName );
      out.write("</option>\n\t\t\t\t");

			} while (rs.next());
		
      out.write("\n\t\t");
      out.write("</select>\n\t\t");
      out.write("<br>\n\t\t");
      out.write("<input type=\"image\" src=\"buttons/bearbeiten.gif\" name=\"changeGroup\" >\n\t\t");
      out.write("<input type=\"image\" src=\"buttons/entfernen.gif\" name=\"deleteGroup\" >");
      out.write("<br>");
      out.write("<br>\n\t");
} else {
      out.write("\n\t\tSie sind bisher in keiner Gruppe Administrator.");
      out.write("<br>");
      out.write("<br>\n\t");
}
      out.write("\n\t");
      out.write("<input type=\"text\" name=\"newGroupName\" value=\"\">\n\t");
      out.write("<input type=\"image\" src=\"buttons/anlegen.gif\" name=\"insertGroup\">\n\t");
      out.write("<input type=\"hidden\" name=\"showGroupAdmin.x\">\n\t");
      out.write("</form>\n\t");
      out.write("</center>\n");
      out.write("</menu>\n");

if(!(deleteGroup || changeAdmin) && groupToChangeID != null) {
	rs = dbConn.query("select groups.name from groups where groupID = " + groupToChangeID);
	
	String groupName = null;
	if (rs.next()) {
		groupName = rs.getString("name");
	}
	else {
		setErrorMessage("Konnte GruppenID nicht aus Datenbank bekommen");
	}	
	rs = dbConn.query("select users.userName from users where userID = " + userID);
	String adminName = null;
	if (rs.next()) {
		adminName = rs.getString("userName");
	}
	else {
		setErrorMessage("Konnte den Namen des Administrators nicht im System finden!");
	}	
	rs = dbConn.query("select users.userID, users.userName from users, rel_uid_gid where rel_uid_gid.groupID = " + groupToChangeID + " and rel_uid_gid.userID = users.userID");
	Vector userNames = new Vector();

      out.write("\n");
      out.write("<div style=\"height:60px\">");
      out.write("</div>\n");
      out.write("<table border=\"0\" width=\"100%\">\n");
      out.write("<tr>\n\t");
      out.write("<td width=\"50%\" valign=\"top\">\n\t\t");
      out.write("<center>\n\t\t\t");
      out.write("<form action=\"mainFrame.jsp\" method=\"post\">\n\t\t\t\t");
      out.write("<table>\n\t\t\t\t");
      out.write("<tr>\n\t\t\t\t\t");
      out.write("<td>\n\t\t\t\t\t\tGruppenname:");
      out.write("<br>\n\t\t\t\t\t\t");
      out.write("<input type=\"text\" name=\"changedGroupName\" size=\"15\" value=");
      out.print(groupName);
      out.write(" >\n\t\t\t\t\t");
      out.write("</td>\n\t\t\t\t\t");
      out.write("<td>\n\t\t\t\t\t\t");
      out.write("<input type=\"image\" src=\"buttons/aendern.gif\" name=\"changeName\" value=\"Ändern\">\n\t\t\t\t\t");
      out.write("</td>\n\t\t\t\t");
      out.write("</tr>\n\t\t\t\t");
      out.write("<tr>\n\t\t\t\t\t");
      out.write("<td>\n\t\t\t\t\t\tNeuer Administrator:");
      out.write("<br>\n\t\t\t\t\t\t");
      out.write("<!--input type=\"text\" name=\"changedAdminName\" size=\"15\" value=\"");
      out.print(adminName);
      out.write("\"/-->\n\t\t\t\t\t\t");
      out.write("<select size=\"5\" style=\"width:200\" name=\"changedAdminName\">\n\t\t\t\t\t\t\t");

							int myUserID = Integer.parseInt(userID);
							while (rs.next()) {
								String currentUserName = rs.getString("userName");
								int currentUserID = rs.getInt("userID");
								if (currentUserID != myUserID) { 
      out.write("\n\t\t\t\t\t\t\t\t\t");
      out.write("<option>");
      out.print(currentUserName);
      out.write("</option>\n\t\t\t\t\t\t\t\t");

								}
								userNames.add(currentUserName);
							}
							
      out.write("\n\t\t\t\t\t\t");
      out.write("</select>\n\t\t\t\t\t");
      out.write("</td>\n\t\t\t\t\t");
      out.write("<td>\n\t\t\t\t\t\t");
      out.write("<input type=\"image\" src=\"buttons/aendern.gif\" name=\"changeAdmin\"/>\n\t\t\t\t\t");
      out.write("</td>\n\t\t\t\t");
      out.write("</tr>\n\t\t\t\t");
      out.write("</table>\n\t\t\t\t");
      out.write("<input type=\"hidden\" name=\"groupToChangeID\" value=\"");
      out.print(groupToChangeID);
      out.write("\">\n\t\t\t\t");
      out.write("<input type=\"hidden\" name=\"showGroupAdmin.x\">\n\t\t\t");
      out.write("</form>\n\t\t");
      out.write("</center>\n\t");
      out.write("</td>\n\t");
      out.write("<td width=\"50%\" valign=\"top\">\n\t\t");
      out.write("<center>\n\t\t\t");
      out.write("<form action=\"mainFrame.jsp\" method=\"post\">\n\t\t\t");
      out.write("<table>\n\t\t\t\t");
      out.write("<tr>\n\t\t\t\t");
      out.write("<td>\n\t\t\t\tMitglied:");
      out.write("<br>\n\t\t\t\t");
      out.write("<input type=\"text\" name=\"newUserName\" value=\"\">\n\t\t\t\t");
      out.write("</td>\n\t\t\t\t");
      out.write("<td>\n\t\t\t\t");
      out.write("<input type=\"image\" src=\"buttons/einfuegen.gif\" name=\"insertUser\" value=\"Einfügen\">\t\n\t\t\t\t");
      out.write("</td>\n\t\t\t\t");
      out.write("</tr>\n\t\t\t\t");
      out.write("<tr>\n\t\t\t\t");
      out.write("<td>\n\t\t\t\tMitglieder:");
      out.write("<br>\n\t\t\t\t");
      out.write("<select size=\"5\" style=\"width:200\" name=\"members\">\n\t\t\t\t\t");

					Iterator iter = userNames.iterator();
					while (iter.hasNext()) {
						String currentUserName = (String) iter.next();
						
      out.write("\n\t\t\t\t\t\t\t");
      out.write("<option>");
      out.print(currentUserName);
      out.write("</option>\n\t\t\t\t\t\t");

					}
					
      out.write("\n\t\t\t\t");
      out.write("</select>\n\t\t\t\t");
      out.write("</td>\n\t\t\t\t");
      out.write("<td>\n\t\t\t\t");
      out.write("<input type=\"image\" src=\"buttons/entfernen.gif\" name=\"removeUser\" value=\"Entfernen\">");
      out.write("<br>\n\t\t\t\t");
      out.write("</td>\n\t\t\t\t");
      out.write("</tr>\n\t\t\t\t");
      out.write("</table>\n\t\t\t\t");
      out.write("<!--input type=\"hidden\" name=\"groupName\" value=\"");
      out.print(groupName);
      out.write("\"-->\n\t\t\t\t");
      out.write("<input type=\"hidden\" name=\"groupToChangeID\" value=\"");
      out.print(groupToChangeID);
      out.write("\">\n\t\t\t\t");
      out.write("<input type=\"hidden\" name=\"showGroupAdmin.x\">\n\t\t\t");
      out.write("</form>\n\t\t");
      out.write("</center>\n\t");
      out.write("</td>\n");
      out.write("</tr>\n");
      out.write("</table>\n");
}
      out.write("\n");
    } catch (Throwable t) {
      out = _jspx_out;
      if (out != null && out.getBufferSize() != 0)
        out.clearBuffer();
      if (pageContext != null) pageContext.handlePageException(t);
    } finally {
      if (_jspxFactory != null) _jspxFactory.releasePageContext(pageContext);
    }
  }
}
