<%@ page import="java.util.GregorianCalendar" %>
<%@ page import="beans.date.ShowableTermin" %>
<%@ page import="beans.date.ConflictTermin" %>
<%@ page import="beans.date.ShowTermin" %>
<%@ include file = "standardheadWOhtml.jsp"%>

<jsp:useBean id="dates" class="beans.date.TerminPreparator" scope="session" />
<jsp:useBean id="navigation" class="beans.TableNavigation" scope="session" />

<%
	String userID = logger.getUserID();
	int numberOfDaysToShow = 7;
	ResultSet rs = null;

	if (beans.Tools.isKeyInRequest(request, "IncreaseOneMonth"))		navigation.increaseOneMonth();
	else if (beans.Tools.isKeyInRequest(request, "IncreaseOneWeek")) 	navigation.increaseOneWeek();
	else if (beans.Tools.isKeyInRequest(request,"IncreaseOneDay")) 		navigation.increaseOneDay();
	else if (beans.Tools.isKeyInRequest(request,"DecreaseOneDay")) 		navigation.decreaseOneDay();
	else if (beans.Tools.isKeyInRequest(request,"DecreaseOneWeek"))		navigation.decreaseOneWeek();
	else if (beans.Tools.isKeyInRequest(request,"DecreaseOneMonth"))	navigation.decreaseOneMonth();

	
	GregorianCalendar cal = navigation.getFirstDayToShow();
	
	if(beans.Tools.isKeyInRequest(request,"MondayFirst")){
		navigation.setDayOffsetForMondayFirst(cal);
		cal = navigation.getFirstDayToShow();	
	}
	else if(navigation.isfirstLoad() || beans.Tools.isKeyInRequest(request,"Today")){
		navigation.setDayOffset(0);
		cal = new GregorianCalendar();
		rs = dbConn.getUsersData(userID);
		if(rs != null ){
			rs.next();
			String firstDayToShow = rs.getString("firstDayToShow");
			if(firstDayToShow.equals("Monday")) {
				navigation.setDayOffsetForMondayFirst(cal);
			}
		}
		cal = navigation.getFirstDayToShow();
	}
	
	navigation.setfirstLoad(false);
	
	int timeInterval = 30;

	rs = dbConn.getUsersData(userID);;
	if(rs != null ){
		rs.next();
		String timeIntervalString = rs.getString("intervall");
		timeInterval = Integer.parseInt(timeIntervalString);
	}
	
%>

<table width="100%" border="1" cellspacing="0" cellpadding="0">
	<tr>
		<td width="9%" valign="top">
	
			<table border="1" width="100%" cellspacing="0" cellpadding="0">
				<tr height="45px">
					<td width="100%">&nbsp;</td>
				</tr>
				<% 
					// Zeittabelle links	
					GregorianCalendar clock = new GregorianCalendar();
					clock.set(Calendar.HOUR_OF_DAY, 0);
					clock.set(Calendar.MINUTE, 0);
					int day = clock.get(Calendar.DAY_OF_MONTH);
					
					while(clock.get(Calendar.DAY_OF_MONTH) == day){
						
						if(cal.get(Calendar.HOUR_OF_DAY) == clock.get(Calendar.HOUR_OF_DAY) && cal.get(Calendar.MINUTE) - clock.get(Calendar.MINUTE) < timeInterval && cal.get(Calendar.MINUTE) - clock.get(Calendar.MINUTE) >= 0){ 
							out.print("<tr height='" + timeInterval + "px'><td width='100%' style='font-size:10; "); 
							out.print(" background-color:#FF0000;'><center>" + tools.getTime(clock));
							out.println("</center></td></tr>");
						}else{
							out.print("<tr height='" + timeInterval + "px'><td width='100%' style='font-size:10; "); 
							out.println("'><center>" + tools.getTime(clock));
							out.println("</center></td></tr>");
						
						}
						
						clock.add(Calendar.MINUTE, timeInterval);
					}
				 %>
			</table>
		</td>

	<% 
	GregorianCalendar _day = (GregorianCalendar)cal.clone();
	//String view;
	String groupOrUserView;
	if(beans.Tools.isKeyInRequest(request, "groupToViewID")){
			String groupID = request.getParameter("groupToViewID");
			groupOrUserView = "groupToViewID=" + groupID; 
			dates.prepareTerminesToShow(userID, groupID, _day, numberOfDaysToShow);
		}
		else{
			groupOrUserView = "";
			dates.prepareTerminesToShow(userID, _day, numberOfDaysToShow);
		}
	
	for(int i=0; i<numberOfDaysToShow; i++){ 		
		
	%>
		<td width="13%" valign="top">

			<table border="1" cellspacing="0" cellpadding="0" width="100%" height="100%">
				<tr height="45px">
					<td style="font-size:17px";><center><%= tools.getDay(cal,i) + "<br>" + tools.getDate(cal,i)%></center></td>
				</tr>
				<tr height="100%">
					<td width="100%">
					<%
					int length = dates.termineCount(i);

					for(int j= 0; j < length; j++){
						ShowableTermin termi = (ShowableTermin)dates.getTerminAt(i,j);
							
						String dTitle = "";
						String comment = "";
						String dCommentString = "";
						GregorianCalendar dBegin = termi.getBegin();			
						GregorianCalendar dEnd 	 = termi.getEnd();
						GregorianCalendar realBegin;			
						GregorianCalendar realEnd;
						int dateID =  -1;
						int broken = termi.isBroken();
						int color = termi.getColor();
						String colorString = "white";
						if(color ==ShowableTermin.CONFLICT) 	 colorString = "red";
						else if(color ==ShowableTermin.GROUP) 	 colorString = "#66CCFF";
						else if(color ==ShowableTermin.PERSONAL) colorString = "#CCFFCC";

						if(termi.isReadable()){	
							dTitle = termi.getTitle();
							dTitle = tools.stringRestrictor(dTitle, 12);
							if(	broken == ShowableTermin.BROKEN_AT_BEGIN) 		dTitle = "&uarr; " + dTitle; 
							else if(broken == ShowableTermin.BROKEN_AT_END) 	dTitle = dTitle + " &darr;"; 
							else if(broken == ShowableTermin.BROKEN_EVERYWHERE) dTitle = "&uarr; " + dTitle + " &darr;"; 
							
							dCommentString = termi.getComment();
							
							if(termi instanceof ShowTermin) {
								dateID = termi.getDateID();
								realBegin = ((ShowTermin)termi).getRealTermin().getBegin();
							 	realEnd = ((ShowTermin)termi).getRealTermin().getEnd();
								comment = tools.getComment(realBegin, realEnd, dCommentString, dTitle);							 
							}
							comment = tools.stringRestrictor(comment, 70);
						}
						else{
							if(termi instanceof ShowTermin) {
								realBegin = ((ShowTermin)termi).getRealTermin().getBegin();
							 	realEnd = ((ShowTermin)termi).getRealTermin().getEnd();
								comment = tools.getComment(realBegin, realEnd, "", "");
							}
							comment =  comment + " Dies ist ein Termin einer anderen Person in dieser Gruppe!!!" ;
							colorString = "#FFCC66";
						}
			
						
						int dPriority = termi.getPriority();
						
						int anfang = ((dBegin.get(Calendar.HOUR_OF_DAY)) * 60) + dBegin.get(Calendar.MINUTE);
						int houreOfDayEND = dEnd.get(Calendar.HOUR_OF_DAY);
						int minuteOfDayEnd = dEnd.get(Calendar.MINUTE);
						if(houreOfDayEND == 0 && minuteOfDayEnd == 0) houreOfDayEND = 24;
						int ende = (houreOfDayEND * 60) + minuteOfDayEnd;
						
						int height = ende-anfang;
						if(height < 20) dTitle = "";
						String divStyleAttribut = " style=\" background:" + colorString + "; text-align:center; overflow:hidden; border-bottom:1px solid black; height:" + height +"px; font-size:15px; color:black\"";
						String divStyleAttributWithAltAndTitleAttr = divStyleAttribut + "alt=\""  +  comment + "\" title=\"" + comment + "\"";							



						if(color ==ShowableTermin.DUMMY){
						%>
						<div <%= divStyleAttribut%>></div>	
						<%}
						
						else if(color ==ShowableTermin.PERSONAL || color ==ShowableTermin.GROUP){%>					  

							<% 
							if(termi.isEditable() && termi.isReadable()){%>
								<a href="mainFrame.jsp?actionChange=<%if(color ==ShowableTermin.GROUP) out.print("groupdate");else out.print("userdate");%>&dateID=<%= dateID%>&showDateEditor=&<%= groupOrUserView%>" alt="<%= comment %>" title="<%= comment %>">
									<div <%= divStyleAttributWithAltAndTitleAttr%>><%= dTitle%></div>
								</a>
							<%}else{out.print("<div " + divStyleAttributWithAltAndTitleAttr + ">" + dTitle + "</div>");}		
						}
						
						else{%>					  
							<a href="mainFrame.jsp?VectorX=<%= i%>&VectorY=<%= j%>&<%= groupOrUserView%>">
							<div <%= divStyleAttribut%>></div></a>	
						<%}
						
						 }//Ende for schleife %>
					</td>
				</tr>	
		</table>
	</td>
<% }

 %>
</tr>
</table>



